BitSensor = require('bitsensor-node-js');
BitSensor.setConfig(require('./config.json'));

const EnvironmentHandler = require('bitsensor-node-js-core/core/handler/environment_handler');
const express = require('express');
const cookieParser = require('cookie-parser');
const bodyParser = require('body-parser');
const fs = require('fs');
const session = require('express-session');
const https = require('https');

const app = express();
app.use(bodyParser.json());
app.use(cookieParser());
app.use(session({
  secret: 'm4F3ePd452Ds45GdvnwDfe35gF',
  saveUninitialized: true,
  resave: true,
}));

const privateKey = fs.readFileSync(`${__dirname}/app.key`, 'utf8');
const certificate = fs.readFileSync(`${__dirname}/app.crt`, 'utf8');
const credentials = { key: privateKey, cert: certificate, rejectUnauthorized: false };

app.use(BitSensor.MiddlewareExpress.startTrace);

app.get('/', (req, res, next) => {
  bitSensor.runSession(() => {
    bitSensor.runSession(() => {
      bitSensor.addPostHandler(new EnvironmentHandler());
      res.send('approved');
      next();
    });
  });
});
app.get('/err', () => {
  throw new Error('ok');
});

app.use(BitSensor.MiddlewareExpress.stopTrace);

app.set('port', 8443);
const server = https.createServer(credentials, app).listen(app.get('port'), () => {
  console.log(`Server started on port ${app.get('port')}`);
});

module.exports = {
  app,
  server,
};
